 <div align="center">

   <img src="https://github.com/loco-rs/loco/assets/83390/992d215a-3cd3-42ee-a1c7-de9fd25a5bac"/>

   <h1>Loco</h1>


   [![crate](https://img.shields.io/crates/v/loco-rs.svg)](https://crates.io/crates/loco-rs)
   [![docs](https://docs.rs/loco-rs/badge.svg)](https://docs.rs/loco-rs)
   [![Discord channel](https://img.shields.io/badge/discord-Join-us)](https://discord.gg/fTvyBzwKS8)

 </div>

[English](./README.md) · 中文 · [Français](./README.fr.md) · [Portuguese (Brazil)](./README-pt_BR.md) ・ [日本語](./README.ja.md) · [한국어](./README.ko.md) · [Русский](./README.ru.md)

Loco 是一个用 Rust 编写的 Web 框架，类似于 Rails。Loco 提供快速构建 Web 应用的功能，并且允许创建自定义任务，可以通过 CLI 运行。

## 特性

- **简单的 API**: 使用 Rust 的强类型系统确保安全性和可靠性。
- **快速开发**: 提供快速构建 Web 应用的工具和模板。
- **CLI 支持**: 可以创建和运行自定义 CLI 任务。
- **灵活性**: 支持自定义配置和扩展。

## 安装

通过 Cargo 安装 Loco:

```sh
cargo install loco
```

## 快速开始

创建一个新的 Loco 项目:

```sh
loco new my_project
cd my_project
```

启动开发服务器:

```sh
loco server
```

## 贡献

欢迎对 Loco 的贡献！请阅读 [CONTRIBUTING.md](CONTRIBUTING.md) 了解更多信息。

## 许可证

Loco 在 MIT 许可证下发布。详情请参阅 [LICENSE](LICENSE)。

---

For more details, you can visit the [original README file](https://github.com/loco-rs/loco/blob/master/README.md).
