# Loco CLI

Loco is a powerful framework designed to streamline the development of modern web applications with a focus on ease of use and flexibility. Whether you're building a SaaS app, a REST API, or a minimal service, Loco provides the tools you need to get started quickly and scale as your application grows. With built-in configuration for popular databases, background workers, and asset serving options, Loco gives you the power to customize your project to fit your needs.

## Templates Versatile Options
Loco empowers you to tailor your project to fit a variety of needs. Here are some of the versatile options it offers:

### Application Types
* **SaaS Applications:** Create platforms with features like user authentication, database integration, and scalable background processing.
* **REST APIs:** Build robust APIs with database support, authentication, and modular controllers.
* **Lightweight** Services: Focus on simplicity with minimal setups that include only essential controllers and views.

#### Advanced Customization
Loco is designed to offer advanced customization to meet the unique needs of your project. Whether you need a simple app that can evolve over time or a complex application that requires a specific configuration, Loco provides the flexibility to fine-tune your setup.


## Getting Started

To install the Loco CLI on your machine, simply run the following command in your terminal:
```sh
cargo install loco
```
This will install the latest version of Loco globally, making it accessible from anywhere in your terminal.

## Create a New Project:
Once installed, you can create a new Loco project by running the following command:
```sh
loco new
```
This will initiate a wizard that will guide you through the process of setting up your project.

## Upgrade
The Loco CLI is bundled with the Loco framework create version. To ensure you're using the latest version of Loco and to get the most up-to-date templates, simply run the following command:
```sh
cargo install loco
```
This will update the Loco CLI to the latest version, replacing the existing loco binary with the newest release. After upgrading, any new templates you generate will reflect the latest features and improvements.